package cn.wise.sc.cement.business.util;

import freemarker.template.Configuration;
import freemarker.template.Template;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Map;

/**
 * @description:
 * @author: qh
 * @create: 2020-10-10 15:22
 **/
public class WordUtil {

    /**
     * 模板路径
     */
    private static final String FTL_FP = "/templates/";

    private static Configuration configuration;

    static {
        configuration = new Configuration(Configuration.DEFAULT_INCOMPATIBLE_IMPROVEMENTS);
        configuration.setDefaultEncoding("utf-8");
        //读配置文件
//        path = PropertiesUtil.get("FILE_PATH")+"/";

    }

    public static Boolean writeWordReport(
            String templeName,
            String templateFileName,
            Map<String, Object> beanParams,
            HttpServletResponse response) {
        Writer out = null;
        File file = null;
        try {
            configuration.setClassForTemplateLoading(WordUtil.class, FTL_FP);
            Template template = configuration.getTemplate(templateFileName, "UTF-8");

            //将文件输出到response,返回给客户端
            String filePath;
            filePath = "";
            File file1 = new File(filePath);
            if (!file1.exists()) {
                file1.mkdirs();
            }
            //变量替换
            //输出文件
            file = new File(filePath + templeName);
            FileOutputStream fos = new FileOutputStream(file);
            out = new OutputStreamWriter(fos, StandardCharsets.UTF_8);
            template.process(beanParams, out);

            FileInputStream in = new FileInputStream(file);
            byte[] buffer = new byte[in.available()];
            in.read(buffer);
            in.close();
            response.reset();
            ServletOutputStream outputStream = response.getOutputStream();
            response.setCharacterEncoding(StandardCharsets.UTF_8.toString());
            response.setContentType("application/octet-stream");
            templeName =  new String((templeName).getBytes(StandardCharsets.UTF_8), StandardCharsets.ISO_8859_1);
            response.setHeader("Content-Disposition", "attachment;filename=" + templeName + ".xls");
            outputStream.write(buffer);
            outputStream.flush();
            outputStream.close();
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        } finally {
            try {
                if (out != null) {
                    out.close();
                    file.delete();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

}
